Bug 59998 - RH7.2 installer refuses to see partitions on harddisk; RH6.2 works OK
RH7.2 installer refuses to see partitions on harddisk; RH6.2 works OK
Status: CLOSED CURRENTRELEASE
Product: Red Hat Linux
Classification: Retired
Component: anaconda (Show other bugs)
7.2
i686 Linux
medium Severity medium
: ---
: ---
Assigned To: Jeremy Katz
Mike McLean
:
Depends On:
Blocks: 61901 67218 79579 CambridgeTarget
  Show dependency treegraph
 
Reported: 2002-02-18 14:46 EST by Ed Voncken
Modified: 2007-04-18 12:40 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2003-10-23 15:56:22 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Ed Voncken 2002-02-18 14:46:14 EST
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:0.9.7) Gecko/20011221

Description of problem:
Harddisk (Fujitsu MPB3064ATU) was repartitioned, Windows 98 installed. Remainder
of disk was left unallocated at first.

RedHat 7.2 installer (Custom installation) aborts on every option to
review/create partitions on this disk (tried automatic, disk druid and fdisk).
See below for error message.

Toms Root/Boot disk has no problems viewing the partitions and partitioning this
drive (regardless of the strange geometry the disk reports). Swap and Ext2
partitions were created to fill the disk.

RedHat 6.2 installer works perfectly, sees the partitions and wants to proceeed.

RedHat 7.2 installer still aborts with fatal error.

This appears to be a regression from RedHat Linux 6.2

Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1. Start RedHat Linux 7.2 installer from CDROM
2. Accept defaults, choose Custom installation
3. Try to partition the harddisk --> installer aborts with fatal error.
	

Actual Results:  Error message:
"The partition table on device hda was unreadable. To create new partitions it
must be initialized, causing the loss of ALL DATA on this drive.

Would you like to initialize this drive?"


Expected Results:  Proceed as usual, or at least give me the option to manually
override the geometry. Unfortunately, this is considered 'too expert' for
'expert' mode...

Additional info:

Machine:
- ASUS P2L97-S mainboard with onboard SCSI (aic7xxx)
- 433MHz Intel Celeron CPU
- 384MB RAM
- CDROM Plextor Ultraplex SCSI
- CDR   Plextor Plexwriter 412C SCSI
- Harddisk IDE
    Fujitsu MPB3064ATU
    Geometry (BIOS)  788/255/63
    Geometry (Linux) 256/255/63

Machine was repartitioned, Windows 98 installed. Partition table:

part  start end  
hda1      1 447  0b Win98

Remainder of disk was left unallocated at first.


RedHat 7.2 installer (Custom installation) aborts on every option to
review/create partitions on this disk (tried automatic, disk druid and fdisk)
with the following error message:

"The partition table on device hda was unreadable. To create new partitions it
must be initialized, causing the loss of ALL DATA on this drive.
Would you like to initialize this drive?"

Of course, I selected "No" and the installer aborted with a fatal error.

Several attempts were made, even by switching to a console before entering the
"partitioning" part of the installer. fdisk reported that it could not open the
device and quit.


Next, I tried Toms Root/Boot floppy. No problems; fdisk read the disk just fine,
and I created partitions after overriding the Cylinder count in fdisk (menu x->c
788).

Partition info:
part  start end  
hda1      1 447  0b Win98
hda2    448 496  82 swap
hda3    497 788  83 Linux native

RedHat Linux 7.2 installer still refused to work with this harddisk and offered
me no way of overriding this behaviour. It doesn't give an explanation of the
exact nature of the problem.

I'm *GUESSING* it has to do with the geometry that is reported by the disk
(256/255/63 instead of the 788/255/63 value used for LBA).

Next, I tried the RedHat Linux 6.2 installer. To my surprise, it had no problems
whatsoever with my configuration (after all, Windows 98 runs just fine on it).

Impact: Cannot install RedHat Linux 7.2 on this machine.

This is a very unfortunate regression from RedHat Linux 6.2.
Comment 1 Jeremy Katz 2002-02-19 02:11:14 EST
If you go to tty2 during the install and run parted on your drive and run
'print' , what does it show for the drive?
Comment 2 Ed Voncken 2002-02-19 09:23:53 EST
I ran the following commands:

# parted /dev/hda print
Error: Could not stat device /dev/hda - No such file or directory.
Retry Cancel?

# fdisk /dev/hda
Unable to open /dev/hda

It appears the device entry does not even exist (ls -l /dev confirms this).
When looking under /proc, it seems that the kernel DOES know about the drive:

# cat /proc/ide/hda/model
FUJITSU MPB3064ATU

# cat /proc/ide/hda/driver
ide-driver version 1.10

# cat /proc/ide/hda/geometry
physical  4092/16/64
logical   256/255/64

Strange; has the installer changed so dramatically since RH6.2?

Could it be that the ide-driver forgets to register the device under /dev ?

Greetings,
  Ed.
Comment 3 Jeremy Katz 2002-02-19 11:57:06 EST
The installer doesn't create all of the device nodes (it creates them on the fly
as it uses them).  You can just run `mknod /dev/hda` and it will create it
correctly for you and then run parted.
Comment 4 Ed Voncken 2002-02-21 16:14:44 EST
Hrmm, no copy & paste for me ;)

# mknod /dev/hda
# parted /dev/hda print
Error: Can't have a partition outside the disk!

# fdisk -l /dev/hda

Disk /dev/hda: 255 heads, 63 sectors, 256 cylinders
Units = cylinders of 16065 * 512 bytes

/dev/hda1  *    1  447   0b
/dev/hda2     448  496   82
/dev/hda3     497  788   83

Obviously fdisk / parted see the disk as C/H/S = 256/255/63. What puzzles me is
that RH62 install does allow me to proceed, while RH72 install bombs out.

I guess that if the RH72 installer allowed me to run fdisk anyway (and let me
set the CHS manually), installation would be possible.

Greetings,
  Ed.
Comment 5 Jeremy Katz 2002-02-22 11:47:38 EST
As of Red Hat Linux 7.2, we use parted as our partitioning backend instead of
libfdisk...
Comment 6 Ed Voncken 2002-03-06 09:16:17 EST
Any idea what's gonna happen next?

Greetings,
  Ed.
Comment 7 pdh 2002-03-08 07:52:00 EST
Hi Folks,

I also have a very similar problem. I'm trying to upgrade from RH7.0 to RH7.2 and the install sequence fails.

Fdisk crashes the install, whereas disk druid gives me the message "The partition table on device hda was unreadable."

If, at the point of failure I switch to a console window and enter  fdisk /dev/hda it is unable to open /dev/hda. However, from the console window, I am 
able to mount hda partitions manually - but unable to continue with the installation.

My disk is (IBM-DJNA-351520-(PM) and partitions are as follows:
  pri hda1 msdos
  log hda5 msdos
  log hda6 msdos
  log hda7 msdos
  log hda8 /boot of 16MB Linux format
  pri hda3 /swap of 196MB Linux swap format
  pri hda4 / of remainder of about 15 MB.
It is setup as a dual boot disk using LILO boot record on the MBR to boot into Windows NT or Linux 7.0. It works perfectly.

I can run the Linux 7.0 installation CD and it recognises all my partitions.

I have tried replacing the drive with a Western Digital which installs RH7.2 perfectly - apparently eliminating  causes outside of hda.

CONCLUSION
--------------------
I believe the hard disk driver is OK because I am able to mount the existing partitions manually when install fails.

I suspect that both fdisk and diskdruid are failing to read my partition table due to their own bugs or lack of versatility.

My partitions are good because they boot up into NT4 and RH7.0, also from RH7.0 install CD.

I expect the upgrade installation of RH7.2 CD would proceed reasonably if only fdisk or diskdruid would allow it to.

Disk Druid and/or fdisk seem to have regressed since version 7.0.

Is there a workround - e.g. to skip the diskdruid/fdisk part of install?

Hope this helps.

Peter

Comment 8 pdh 2002-04-04 16:30:20 EST
I've solved the problem folks. It seems that RH6.2 created an error in my
partition table, an error which it was tollerant of! When I run RH7.2 that it
fails to recognise /dev/hda, instead of reporting (or tollerating) faulty
partion table. I've used parted to correct the problem, and all is OK now. Many
thank for contributions of others in this bug report.

Peter.
Comment 9 pdh 2002-04-07 05:36:34 EDT
Oh, the troubles I had getting this problem fixed! There are so many bugzilla
reports that could have been something to do with it. I can't be sure of all the
details now - I considered it a one off so didn't make my own notes.

The breakthrough came for me when I tried the following commands. When the
installation failed, I was able to switch to console Ctrl Alt F2 and enter the
following commands as advised in bug 59998.

# mknod /dev/hda
# parted /dev/hda print
# fdisk -l /dev/hda

The parted command gave me a rude message but the fdisk command showed my
partiton table. On very, very close inspection I noticed an error in the table.
Two of my partitions were overlapping. It must have been RH6.2 that did this to
me. RH6.2 did not mind the overlap, even on reinstallation. I must have used
fdisk to fix the overlap and then tested that parted could see my partitions as
expected.

Sorry, I think I misled you to believe I fixed it with parted, when it was
really fdisk.

Hope this helps. Make sure you let me know if you need more detail.

Regards,
Peter.
Comment 10 marty rampton 2002-04-10 01:27:18 EDT
i had a similar problem, but with a different solution.  in my case, the 
partitions weren't seen at all by the 7.2 installer..  this was due to some 
sort of crippled BIOS (aic7xxx) drivers.  running the install using login of 
type:

linux apic

..made all the bad stuff go away.  only took us a combined 8 hours to come up 
with those magic 4 characters!

hope that helps.
Comment 11 Matt Wilson 2002-04-16 16:54:42 EDT
martyrampton@hotmail.com, I know you're trying to help, but 'linux apic' isn't
the solution to every problem.
Comment 12 Matt Wilson 2002-04-16 17:11:11 EDT
Please run the following on VC2:

# mknod /dev/hda
# echo -e "x\np" | fdisk /dev/hda > fdisk.out
insert a DOS formatted floppy in your floppy drive
# mcopy fdisk.out a:

and attach the file.
Comment 13 Michael Fulbright 2002-05-13 15:19:26 EDT
Closing due to inactivity, please reopen if you have any additional information.
Comment 14 Ed Voncken 2002-06-03 13:13:16 EDT
As requested by msw, I got the following partition info after running the RH 7.2
installer:

Command (m for help): 
Expert command (m for help): 
Disk /dev/hda: 255 heads, 63 sectors, 256 cylinders

Nr AF  Hd Sec  Cyl  Hd Sec  Cyl    Start     Size ID
 1 80   1   1    0 254  63  446       63  7180992 0b
 2 00   0   1  447 254  63  495  7181055   787185 82
 3 00   0   1  496 254  63  787  7968240  4690980 83
 4 00   0   0    0   0   0    0        0        0 00

Expert command (m for help): Expert command (m for help): Expert command (m for
help):
Comment 15 Ed Voncken 2002-06-03 13:17:48 EDT
Reproduced the same problem on RedHat 7.3; fdisk output as requested by msw also
reproduced on RH 7.3:

Command (m for help): 
Expert command (m for help): 
Disk /dev/hda: 255 heads, 63 sectors, 256 cylinders

Nr AF  Hd Sec  Cyl  Hd Sec  Cyl    Start     Size ID
 1 80   1   1    0 254  63  446       63  7180992 0b
 2 00   0   1  447 254  63  495  7181055   787185 82
 3 00   0   1  496 254  63  787  7968240  4690980 83
 4 00   0   0    0   0   0    0        0        0 00

Expert command (m for help): Expert command (m for help): Expert command (m for
help):
Comment 16 Jeremy Katz 2003-10-23 15:56:22 EDT
This should be better in our current codebase.

Note You need to log in before you can comment on or make changes to this bug.